/***************************************************************************
****************************************************************************

This is a part of the xModule Source code.

Copyright (C) 2003-2009 The LS-Universe Team

  Homepage: http://www.ls-universe.info

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

****************************************************************************
****************************************************************************/
/*
 * A lot of this code originally came from bbClean but most of it has been
 * totally rewritten by me, Tobbe Lundberg.
 * Some of it is from the original xPaintClass code written by Andymon.
 */

#ifndef _GRADIENT_H_
#define _GRADIENT_H_

class Gradient
{
private:
    DWORD *pixels;

    void setup_bv4info(BITMAPINFO *bv4info);
    void diagonalGradient(double k);

protected:
    COLORREF colorFrom;
    COLORREF colorTo;
    DWORD *xtab;
    DWORD *ytab;
    int width;
    int height;

    virtual void paintPixel(DWORD *p, int x, int y) {}
    void createColorScale(DWORD *p, int length);
    void quadrantGradient();

public:
    Gradient(int width, int height, COLORREF colour_from, COLORREF colour_to);
    ~Gradient();
    void verticalGradient();
    void horizontalGradient();
    void ulTolrGradient(); //Upper-left to lower-right
    void urTollGradient(); //Upper-right to lower-left
    virtual void generateGradient() {}
    void copyToHdc(HDC hDC, int px, int py, int w, int h);
    DWORD *getPixels();
};

#endif
